SystemOrganization addCategory: #'WebClient-Help'!

CustomHelp subclass: #WebClientHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-Help'!

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:14'!
authentication
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #authentication"
	^HelpTopic
		title: 'Authentication'
		contents: 
'WebClient supports basic and digest authentication by default. WebClient delegates the retrieval of username/password to WebUtils which prompts the user for credentials. 

WebClient can either be supplied with specific credentials to be used or custom credentials handlers, for example:

	| client |
	client := WebClient new.
	client username: ''squeak''.
	client password: ''squeak''.
	client httpGet: ''http://www.squeak.org/protected''.

Proxy authentication works the same way as authentication but operates on a different authentication context to allow different sets of credentials to work.
!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'accessing' stamp: 'ar 5/4/2010 12:51'!
bookName
	"Returns the name of the custom help book"

	^'WebClient'! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:13'!
cookieSupport
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #cookieSupport"
	^HelpTopic
		title: 'Cookie Support'
		contents: 
'WebClient supports session cookies. Cookies are preserved within one WebClient session but not across multiple session (cookies can be copied or shared between WebClients which makes it easy to support where needed). Support for cookies can be disabled via WebClient''s #acceptCookies: property.
!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 12:50'!
introduction
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #introduction"
	^HelpTopic
		title: 'Introduction'
		contents: 
'WebClient is a simple, yet reasonably complete HTTP client. WebClient uses HTTP 1.1, supports proxies (both authenticating and not), redirect support and authentication.

WebClient comes with WebServer, an HTTP server implementation with a similarly simple yet reasonably complete approach.!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:07'!
multipleRequests
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #multipleRequests"
	^HelpTopic
		title: 'Multiple Requests'
		contents: 
'WebClient can and should be used for multiple requests to the same host. This will ensure persistent connections as well as having cookies processed properly within one session:

	| client resp |
	client := WebClient new.
	resp := 	client httpGet: ''http://www.squeak.org/''.
	resp := 	client httpGet: ''http://www.squeak.org/Download''.
	resp := 	client httpGet: ''http://www.squeak.org/Features''.
	client close.

Requests to different hosts in one session can be made as well but hasn''t been extensively tested as of yet.
!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'accessing' stamp: 'ar 5/4/2010 21:13'!
pages 
	"Returns a collection of method selectors to return the pages of the custom help book"
		
	^#(introduction webClientRequests webClientResponses multipleRequests authentication redirectSupport proxySupport cookieSupport)! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:12'!
proxySupport
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #proxySupport"
	^HelpTopic
		title: 'Proxy Support'
		contents: 
'WebClient supports connecting via http proxies, including authenticating proxies. WebClient delegates proxy detection to its ProxyHandler which is responsible for performing the proper actions. Proxy authentication is handled in a similar way as regular authentication. The defaults are implemented in WebUtils.
!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:09'!
redirectSupport
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #redirectSupport"
	^HelpTopic
		title: 'Redirect Handling'
		contents: 
'WebClient handles http redirect requests (3xx) transparently. WebClient detects infinite redirect loops and gives up after a certain number of attempts, returning the redirect (3xx) response which caused it to give up. Users of WebClient will only see 3xx responses if WebClient has given up (i.e., returning a 3xx should be considered an error).

Redirect handling can be disabled by setting #allowRedirect property to the desired value. When disabled, WebClient will not attempt to perform any redirect handling.!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:00'!
webClientRequests
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #webClientRequests"
	^HelpTopic
		title: 'Using WebClient'
		contents: 
'The simplest form to use WebClient is by one of its convenience APIs:

	WebClient httpGet: ''http://www.squeak.org/''.
	WebClient httpPost: ''http://www.squeak.org/'' content:''Hello Squeak'' type: ''text/plain''.

For more elaborate use of headers and some other options in the request, a client can utilize modified variants:

	WebClient new httpGet: ''http://www.squeak.org/'' do:[:req|
		"Set an if-modified-since header"
		req headerAt: ''If-Modified-Since'' put: ''Sat, 29 Oct 1994 19:43:31 GMT''.
		"Add several accept headers"
		req addHeader: ''Accept'' value: ''text/plain''.
		req addHeader: ''Accept'' value: ''application/x-foo-bar''.
		req addHeader: ''Accept'' value: ''image/jpg''.
	].

The set of utility methods is limited to a few useful ones but it is easy to do the setup on your own:

	| url client request data |
	data := ''Hello Squeak''.								"POST data"
	url := ''http://www.squeak.org/''.						"POST url"
	client := WebClient new initializeFromUrl: url. 		"sets host etc"
	request := client requestWithUrl: url. 				"sets path etc"
	request method: ''POST''.							"sets method"
	request headerAt: ''Content-Length'' put: data size.
	request headerAt: ''Content-Type'' put: ''text/plain''.
	"... any other headers required ..."
	^client sendRequest: request 
		content: data readStream
		size: data size.

The utility methods like httpGet: etc. are similarly simple requests.
!!' readStream nextChunkText! !

!WebClientHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 21:06'!
webClientResponses
	"This method was automatically generated. Edit it using:"
	"WebClientHelp edit: #webClientResponses"
	^HelpTopic
		title: 'Responses'
		contents: 
'The WebClient request methods return a WebResponse that the client can process:

	| resp |
	resp := WebClient httpGet: ''http://www.squeak.org/''.
	[resp isSuccess ifFalse:[^self error: resp status].
	"Process the content from the response"
	^resp content] ensure:[resp close].

In addition, content can be streamed from the response so that it does not need to be downloaded all at once:

	| resp file |
	resp := 	WebClient httpGet: ''http://www.squeak.org/''.
	resp isSuccess ifFalse:[^self error: resp status].
	"Stream the content from the response"
	file := FileStream newFileNamed: ''page.html''.
	[resp streamTo: file 
			size: resp contentLength
			progress:[:total :amount]] ensure:[file close. resp close].

The progress block in the above can be omitted but has been included in this example to illustrate its usage. The block takes a total length (which can be nil if the length is not known) and the amount that has been loaded.
!!' readStream nextChunkText! !

WebClientHelp subclass: #WebClientReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-Help'!

!WebClientReference class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:13'!
bookName
	^'Reference'! !

!WebClientReference class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:12'!
builder
	^PackageAPIHelpBuilder! !

!WebClientReference class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:27'!
packages
	^#('WebClient-Core')! !

CustomHelp subclass: #WebServerHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-Help'!

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:03'!
addingActions
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #addingActions"
	^HelpTopic
		title: 'Adding Actions'
		contents: 
'Let''s add some real stuff that might be useful on a server:

	WebServer default addService: ''/smalltalk'' action:[:req| | action |
		action := (req fields at: ''get'' ifAbsent:['''']) asSymbol.
		req send200Response: (Smalltalk perform: action) asString
	].

We can now request some interesting things like:

	(WebClient httpGet:''http://localhost:8080/smalltalk?get=systemInformationString'') content.
	(WebClient httpGet:''http://localhost:8080/smalltalk?get=platformName'') content.
	
Obviously, this poses quite a risk for abuse. One way to limit this risk is to expose specific actions, such as here:

	#(systemInformationString platformName) do:[:symbol|
		WebServer default addService: ''/info/'', symbol action:[:req|
			req send200Response: (Smalltalk perform: symbol) asString]].

	(WebClient httpGet:''http://localhost:8080/info/systemInformationString'') content.
	(WebClient httpGet:''http://localhost:8080/info/platformName'') content.

Alternatively, authentication can be used to limit access to exposed resources. 
!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:01'!
addingServices
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #addingServices"
	^HelpTopic
		title: 'Adding Services'
		contents: 
'Once the server is running, you can point your browser to http://localhost:8080 but since we haven''t told WebServer what we''d like to do all we get is a 404 (not found) response. To tell WebServer what to do we need to register a service:

	WebServer default addService: ''/hello'' action:[:req|
		req send200Response: ''Hello World''.
	].

The service takes a path (/hello) and an action to perform for any request that maps to this path. We can now fetch the response in a browser by going to http://localhost:8080/hello or directly using WebClient:

	(WebClient httpGet:''http://localhost:8080/hello'') content.
	(WebClient httpGet:''http://localhost:8080/hello/squeak'') content.
!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:03'!
authentication
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #authentication"
	^HelpTopic
		title: 'Authentication'
		contents: 
'To add authentication you can use web server as follows:

	WebServer default addService: ''/smalltalk'' action:[:req| | action |
		WebServer default authenticate: req realm: ''squeak'' methods: #(digest basic) do:[
			action := (req fields at: ''get'' ifAbsent:['''']) asSymbol.
			req send200Response: (Smalltalk perform: action) asString.
		].
	].

The above supports both digest as well as basic authentication for accessing the /smalltalk service. Let''s add a user so that we can access it:

	WebServer default passwordAt: ''squeak'' realm: ''squeak'' put: ''squeak''.

The server does NOT store plain text passwords, but rather hashes. To be precise, it stores the ha1 term used in digest authentication which is the same hash produced by htdigest. We can now access the /smalltalk service by providing user name ''squeak'' and password ''squeak''.

	(WebClient httpGet:''http://localhost:8080/smalltalk?get=platformName'') content.

Unfortunately, digest authentication can be slow since our MD5 implementation is rather pathetic. 
!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:05'!
bookName
	"Returns the name of the custom help book"

	^'WebServer'! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:04'!
cookies
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #cookies"
	^HelpTopic
		title: 'Cookies'
		contents: 
'Because of the performance issues with authentication, we''d like to avoid authentication for each request and instead authenticate once and use some persistent session state (cookies). So let''s do that:

	WebServer default addService: ''/smalltalk'' action:[:req| | session |
		session := WebServer default sessionAt: (req cookieAt: ''session'').
		session ifNil:[ "no session, reguire login"
			req send302Response: ''/login?url='', req rawUrl encodeForHTTP.
		] ifNotNil:[ | target action |
			action := (req fields at: ''get'' ifAbsent:['''']) asSymbol.
			req send200Response: (Smalltalk perform: action) asString.
		].
	].

And of course we now need a login service The service will require authentication and provide a session identifier for the client. It then redirects back to where the request was originally made from:

	WebServer default addService: ''/login'' action:[:req| | session |
		WebServer default authenticate: req realm: ''squeak'' methods: #(digest) do:[ | id |
			"We have no session state for now, just remember the session id"
			WebServer default sessionAt: (id := UUID new hex) put: ''''.
			"Send a redirect back to where we came from with a cookie"
			req send302Response: (req fields at: ''url'' ifAbsent:[''/'']) 
				do:[:reply| reply setCookie: ''session'' value: id path: ''/smalltalk'']]].
!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:08'!
introduction
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #introduction"
	^HelpTopic
		title: 'Introduction'
		contents: 
'WebServer is a simple, yet reasonably complete HTTP server implementation. WebServer supports streaming, authentication, cookies, and session handling in a compact and easy to use form.

The primary goal for WebServer is for command-and-control style interfaces. If you would like to add some web-based remote control facility without much fuzz and html goodness around it, WebServer is for you.

WebServer comes together with WebClient which provides a similarly complete and simple HTTP client implementation.!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:06'!
pages 
	"Returns a collection of method selectors to return the pages of the custom help book"
		
	^#(introduction startingWebServer addingServices serviceHierarchies addingActions authentication cookies summary)! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:02'!
serviceHierarchies
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #serviceHierarchies"
	^HelpTopic
		title: 'Service Hierarchies'
		contents: 
'More specific services are preferred over more general services.  In addition to the /hello service, we can provide a handler for /hello/squeak by adding the following service:

	WebServer default addService: ''/hello/squeak'' action:[:req|
		req send200Response: ''Hello to you too, Squeak!!!!''.
	].

	(WebClient httpGet:''http://localhost:8080/hello'') content.
	(WebClient httpGet:''http://localhost:8080/hello/squeak'') content.

A default handler for any kind of request can installed by using the ''/'' path:

	WebServer default addService: ''/'' action:[:req|
		req send302Response: ''/hello''. "temporary redirect"
	].

This will make any request that isn''t handled by an explicit action redirect to /hello where it will be handled by the handler established earlier, for example:

	(WebClient httpGet:''http://localhost:8080/foobar'') content.

!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 13:00'!
startingWebServer
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #startingWebServer"
	^HelpTopic
		title: 'Starting WebServer'
		contents: 
'A WebServer is started by listening on a particular port. The examples below use ''WebServer reset default'' for convenience; specific applications should have their own registry for accessing various WebServer instances.

	(WebServer reset default)
		listenOn: 8080.

The server will persist when the image is restarted and must be stopped explicitly by sending it the #destroy message.
!!' readStream nextChunkText! !

!WebServerHelp class methodsFor: 'pages' stamp: 'ar 5/4/2010 22:11'!
summary
	"This method was automatically generated. Edit it using:"
	"WebServerHelp edit: #summary"
	^HelpTopic
		title: 'Summary'
		contents: 
'At this point, making a request like the following:

	(WebClient httpGet: ''http://localhost:8080/smalltalk?get=platformName'') content.

requires several roundtrips:

	1) The first GET request is redirected from /smalltalk to /login
	2) The request to /login is responded to with an authentication challenge
	3) The request to /login is authenticated and a session cookie is established
	4) The request is redirected back to /smalltalk where it is finally handled.

More examples for using WebServer can be found in class WebServer itself. Here is an overview:

	* exampleDoIt - the simplest possible RPC interface to Squeak.
	* exampleBrowse - browse the files on your local disk
	* exampleSession - a simple session example
	* exampleAuth - a simple authentication example
!!' readStream nextChunkText! !

WebServerHelp subclass: #WebServerReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-Help'!

!WebServerReference class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:19'!
bookName
	^'Reference'! !

!WebServerReference class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:19'!
builder
	^PackageAPIHelpBuilder! !

!WebServerReference class methodsFor: 'accessing' stamp: 'ar 5/4/2010 13:27'!
packages
	^#('WebClient-Core')! !
